Models/Secret.cs
namespace JournalSecret.Models
{
    public class Secret
    {
        public int Id { get; set; }
        public string Apercu { get; set; }
        public string Description { get; set; }
        public bool Publique { get; set; }
        public string Journal { get; set; }
        public int IdUsager { get; set; }
    }
}

Controllers/FileIOController.cs
using JournalSecret.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.FileProviders;
using Microsoft.Extensions.Hosting.Internal;
using System.Linq;
using System.Reflection;

namespace JournalSecret.Controllers
{
    public class FileIOController : Controller
    {
        private readonly IFileProvider _fileProvider;
        private readonly IWebHostEnvironment _hostingEnvironment;

        public FileIOController(IFileProvider provider, IWebHostEnvironment hostingEnvironment)
        {
            _fileProvider = provider;
            _hostingEnvironment = hostingEnvironment;
        }

        public IActionResult TelechargerFichier(int IdUsager)
        {
            // On cherche le nom du fichier ayant l'identifiant IdUsager
            string fileName = "";
            foreach (var item in _fileProvider.GetDirectoryContents("Files"))
            {
                string subFileName = "Journal" + IdUsager.ToString();
                if (item.Name.Contains(subFileName))
                {
                    fileName = item.Name;
                    break;
                }
            }

            var filePath = Path.Combine(_hostingEnvironment.WebRootPath, "Files", fileName);

            var memoryStream = new MemoryStream();

            try
            {
                using (var stream = new FileStream(filePath, FileMode.Open))
                {
                    stream.CopyTo(memoryStream);
                }

                memoryStream.Position = 0;
                return File(memoryStream, "text/txt", Path.GetFileName(filePath));
            }
            catch (Exception)
            {

                return RedirectToAction("ListeSecretsPublique", "Secret");
            }

        }

        [HttpPost]
        public IActionResult TeleverserFichier(IFormFile fichier, int IdUsager)
        {
            string fileName = "Journal" + IdUsager + fichier.FileName;

            if (fichier != null)
            {
                string filePath = Path.Combine(_hostingEnvironment.WebRootPath, "Files", fileName);

                using (var stream = new FileStream(filePath, FileMode.Create))
                {
                    fichier.CopyTo(stream);
                }
            }

            TempData["filePath"] = Path.Combine(_hostingEnvironment.WebRootPath, "Files", fileName);

            return RedirectToAction("ListeSecretsUsager", "Secret");
        }
    }
}

Controllers/SecretController.cs
using JournalSecret.Models;
using Microsoft.AspNetCore.Mvc;

namespace JournalSecret.Controllers
{
    public class SecretController : Controller
    {
        private readonly SecretsDataContext _dtContext;

        public SecretController(SecretsDataContext dtContext)
        {
            this._dtContext = dtContext;
        }

        [HttpGet]
        public ActionResult ListeSecretsPublique(string searchString)
        {
            List<SecretUsagerViewModel> listeSecrets = this._dtContext.SelectSecretsPubliques();


            if (!String.IsNullOrEmpty(searchString))
            {
                searchString = searchString.ToLower();
                listeSecrets = this._dtContext.RechercherPourPublique(searchString);
                ViewBag.searchString = searchString;
            }

            return View(listeSecrets);
        }

        [HttpGet]
        public ActionResult ListeSecretsUsager(string searchString, int id)
        {
            List<Secret> listeSecrets = this._dtContext.SelectSecretsUsager();


            if (!String.IsNullOrEmpty(searchString))
            {
                searchString = searchString.ToLower();
                listeSecrets = this._dtContext.RechercherPourUsager(searchString);
                ViewBag.searchString = searchString;
            }


            if (id != 0)
            {
                ViewBag.identifiant = id;
            }

            string courriel = HttpContext.Request.Cookies["courriel"];
            Tuple<int, string, string, string> infoUsager = this._dtContext.GetInfoUsager(courriel);

            ViewBag.IdUsager = infoUsager.Item1;
            ViewBag.Prenom = infoUsager.Item2;
            ViewBag.Nom = infoUsager.Item3;
            ViewBag.Alias = infoUsager.Item4;

            return View(listeSecrets);
        }

        public ActionResult Editer(int id)
        {
            Secret secret = this._dtContext.SelectSecret(id);
            return View(secret);
        }

        [HttpPost]
        public ActionResult Editer(Secret secret)
        {
            this._dtContext.ModifierSecret(secret);
            return RedirectToAction(nameof(ListeSecretsUsager));
        }
    }
}

Views/Secret/Editer.cshtml
@model JournalSecret.Models.Secret

@{
    ViewData["Title"] = "Editer";
}

<h1>Editer</h1>

<h4>Secret</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Editer">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Id" class="control-label"></label>
                <input asp-for="Id" class="form-control" />
            </div>
            <div class="form-group">
                <label asp-for="Apercu" class="control-label"></label>
                <input asp-for="Apercu" class="form-control" />
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
            </div>
            <div class="form-group form-check">
                <label class="form-check-label">
                    <input class="form-check-input" asp-for="Publique" /> @Html.DisplayNameFor(model => model.Publique)
                </label>
            </div>
            <div class="form-group">
                <label asp-for="IdUsager" class="control-label"></label>
                <input asp-for="IdUsager" class="form-control" />
            </div>
            <div class="form-group">
                <button type="submit" onclick="alert('Êtes-vous sûr de vouloir modifier votre secret @Context.Request.Query["id"]');" class="btn btn-primary">Sauvegarder</button>
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Liste">Annuler la modification</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

Views/Secret/ListeSecretsPublique.cshtml
@model IEnumerable<SecretUsagerViewModel>

@{
    ViewData["Title"] = "Liste secrets publique";
}

<h1>Liste des secrets</h1>


<form asp-action="ListeSecretsPublique" method="get">
    Recherche: <input type="text" name="searchString" />
    <input type="submit" value="Search" />
</form>

<p>
    <a asp-action="ListeSecretsPublique">Retour vers la liste complète.</a>
</p>


@if (!string.IsNullOrEmpty(ViewBag.searchString))
{
    <p>Résultats pour la recherche : @Html.Raw(ViewBag.searchString) </p>
}

<table class="table">
    <thead>
        <tr>
            <th>Prénom</th>
            <th>Nom</th>
            <th>Alias</th>
            <th>Secret</th>
            <th>Télécharger le journal secret</th>
        </tr>
    </thead>
    <tbody>
    @foreach (var item in Model) 
    {
            <tr>
                <td>@Html.Raw(item.Prenom)</td>
                <td>@Html.Raw(item.Nom)</td>
                <td>@Html.Raw(item.Alias)</td>
                <td>@Html.Raw(item.Apercu)</td>
                <td>
                    <a asp-controller="FileIO" asp-action="TelechargerFichier" asp-route-IdUsager="@item.IdUsager">Journal</a>
                </td>
            </tr>
    }
    </tbody>
</table>

Views/Secret/ListeSecretsUsager.cshtml
@model IEnumerable<Secret>

@{
    ViewData["Title"] = "Liste secrets usager";
}

@{
    var IdUsager = ViewBag.IdUsager;
    var Prenom = ViewBag.Prenom;
    var Nom = ViewBag.Nom;
    var Alias = ViewBag.Alias;
}

<form asp-action="ListeSecretsUsager" method="get">
    Recherche: <input type="text" name="searchString" />
    <input type="submit" value="Search" />
</form>

<p>
    <a asp-action="ListeSecretsUsager" asp-route-id="@IdUsager">Retour vers la liste complète.</a>
</p>


@if (!string.IsNullOrEmpty(ViewBag.searchString))
{
    <p>Résultats pour la recherche : @Html.Raw(ViewBag.searchString) </p>
}

<h1>Liste des secrets de <mark style="color:green">@Prenom @Nom (@@@Alias)</mark> </h1>

<table class="table">
    <thead>
        <tr>
            <th>ID secret</th>
            <th>Secret</th>
            <th>Description</th>
            <th>Publique</th>
            <th>ID usager</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr> 
                <td>@Html.Raw(item.Id)</td>
                <td>@Html.Raw(item.Apercu)</td>
                <td>@Html.Raw(item.Description)</td>
                <td>@Html.Raw(item.Publique)</td>
                <td>@Html.Raw(item.IdUsager)</td>
                <td>
                    <a asp-controller="Secret" asp-action="Editer" asp-route-id="@item.Id"> Modifier </a>
                </td>
            </tr>
        }
    </tbody>
</table>

<form method="post" enctype="multipart/form-data" asp-controller="FileIO" asp-action="TeleverserFichier" asp-route-IdUsager="@IdUsager">
    <div class="form-group">
        <div class="col-md-10">
            <p><b>Téléversez un journal:</b></p>
            <input type="file" name="fichier" />
            <input type="submit" value="Envoyer" />
        </div>
    </div>

    @if (!string.IsNullOrEmpty((string)TempData["filePath"]))
    {
        <p>Votre journal a été enregistrée avec succès dans @TempData["filePath"] </p>
    }
</form>